package dk.nsp.idsas.test.stepdefinitions;

import dk.nsp.idsas.test.util.HttpClient;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.junit.Assert;
import org.springframework.beans.factory.annotation.Value;

import java.io.IOException;

public class HealthEndpointSteps {
    @Value("${idsas.service.endpoint}" + "/status")
    private String healthEndpoint;
    private int responseCode;

    @When("Jeg tjekker servicens health endpoint")
    public void jegTjekkerServicensHealthEndpoint() throws IOException {
        HttpClient httpClient = new HttpClient();
        httpClient.get(healthEndpoint);
        responseCode = httpClient.getResponseCode();
    }

    @Then("Så burde jeg få et {int} OK tilbage")
    public void såBurdeJegFåEtOKTilbage(int expectedResponseCode) {
        Assert.assertEquals(expectedResponseCode, responseCode);
    }
}
