package dk.nsp.idsas.test.stepdefinitions;

import dk.nsp.idsas.test.idptest.SOAPOperation;
import dk.nsp.idsas.test.idptest.ServiceCaller;
import dk.nsp.test.idp.CitizenIdentities;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.GetSaltRequestType;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.springframework.beans.factory.annotation.Value;

import javax.xml.bind.JAXBException;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.net.URI;
import java.net.URISyntaxException;
import java.time.Instant;
import java.util.Date;
import java.util.GregorianCalendar;

public class SaltStepDefinitions {

    @Value("${idsas.service.endpoint}" + "/blurring")
    private String urlBlurring;

    private final ServiceCaller serviceCaller = new ServiceCaller();

    private XMLGregorianCalendar toXmlGregorian(Date date) throws DatatypeConfigurationException {
        GregorianCalendar gregorianCalendar = (GregorianCalendar) GregorianCalendar.getInstance();
        gregorianCalendar.setTime(date);
        return DatatypeFactory.newInstance().newXMLGregorianCalendar(gregorianCalendar);
    }

    @When("Når der forespørges på en salt med en dato")
    public void createBlurring() throws JAXBException, URISyntaxException, DatatypeConfigurationException {
        GetSaltRequestType saltRequest = new GetSaltRequestType();
        saltRequest.setDateTime(toXmlGregorian(Date.from(Instant.now())));

        serviceCaller.callRoot(CitizenIdentities.alanTuring("https://fsk"),
                saltRequest, SOAPOperation.GetSalt, new URI(urlBlurring),
                GetSaltRequestType.class,
                String.class);

    }

    @Then("Så får man en salt")
    public void såFårManEnSalt() {
        // TODO
    }
}