package dk.nsp.idsas.test.stepdefinitions;

import dk.nsp.idsas.test.util.HttpClient;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.springframework.beans.factory.annotation.Value;

import java.io.IOException;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

public class WsdlStepDefinition {

    @Value("${idsas.service.endpoint}")
    private String url;
    private int responseCode;
    private String responseBody;

    @When("{word} wsdl hentes")
    public void getWsdl(String endpoint) throws IOException {
        HttpClient httpClient = new HttpClient();
        responseBody = httpClient.get(String.format("%s/%s?wsdl", url, endpoint));
        responseCode = httpClient.getResponseCode();
    }

    @Then("Returneres http kode {int}")
    public void validateResponseCode(int expectedResponseCode) {
        assertEquals(expectedResponseCode, responseCode);
    }

    @Then("Svaret er ikke tomt")
    public void validateNonEmptyReponseBody() {
        assertFalse(responseBody.isEmpty());
    }
}
