package dk.nsp.idsas.security;

import dk.nsp.idsas.security.model.IdsasActor;

public class IdsasContextBuilder {
    private final IdsasActorProvider idsasActorProvider;
    private final IdsasActorTransformer idsasActorTransformer;
    private final IdsasActorEnricher idsasActorEnricher;
    private final IdsasActorValidator idsasActorValidator;

    public IdsasContextBuilder(IdsasActorProvider idsasActorProvider,
                               IdsasActorTransformer idsasActorTransformer,
                               IdsasActorEnricher idsasActorEnricher,
                               IdsasActorValidator idsasActorValidator) {
        this.idsasActorProvider = idsasActorProvider;
        this.idsasActorTransformer = idsasActorTransformer;
        this.idsasActorEnricher = idsasActorEnricher;
        this.idsasActorValidator = idsasActorValidator;
    }

    public IdsasContext getValidatedContext(String patientId) throws IdsasSecurityException {

        IdsasActor idsasActor = idsasActorProvider.getActor();
        idsasActor = idsasActorTransformer.transformActor(idsasActor);
        idsasActor = idsasActorEnricher.enrichActor(idsasActor);
        return idsasActorValidator.validateIdsasActorAndGetContext(idsasActor, patientId);
    }
}
