package dk.nsp.idsas.security.model;

public class IdsasActor {
    private final IdsasActorType actorType;
    private final String cvr;

    private IdsasActor(IdsasActorType actorType, String cvr) {
        this.actorType = actorType;
        this.cvr = cvr;
    }

    public static IdsasActor createSundhedsFaglig(String cvr) {
        return new IdsasActor(IdsasActorType.SUNDHEDSFAGLIG, cvr);
    }

    public static IdsasActor createSystem(String cvr) {
        return new IdsasActor(IdsasActorType.SYSTEM, cvr);
    }

    public IdsasActorType getActorType() {
        return actorType;
    }

    public String getCvr() {
        return cvr;
    }

    public static enum IdsasActorType {
        SUNDHEDSFAGLIG("Sundhedsfaglig"),
        SYSTEM("System");
        private final String actorType;
        private IdsasActorType(String actorType) {
            this.actorType = actorType;
        }
        public String getDisplayableText() {
            return actorType;
        }
    }
}
