package dk.nsp.idsas.setup;

import org.apache.log4j.Logger;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.PropertySource;
import org.springframework.context.annotation.PropertySources;

import dk.nsp.idsas.security.*;
import dk.nsp.idsas.security.impl.IdsasActorProviderImpl;
import dk.nsp.idsas.security.impl.IdsasActorValidatorImpl;

@Configuration
@PropertySources({
        @PropertySource(value = "idsas.properties", encoding = "ISO-8859-1")
})
public class ServiceSetup {
    public static final String ANNOTATION_CONFIG_CONTEXT = "ANNOTATION_CONFIG_APPLICATION_CONTEXT";
    private static final Logger logger = Logger.getLogger(ServiceSetup.class);

    @Bean
    public IdsasContextBuilder contextBuilder() {
        IdsasActorProvider provider = new IdsasActorProviderImpl();
        IdsasActorTransformer transformer = actor -> actor; // No transforming
        IdsasActorEnricher enricher = actor -> actor; // No enriching
        IdsasActorValidator validator = new IdsasActorValidatorImpl();
        return new IdsasContextBuilder(provider, transformer, enricher, validator);
    }

}
