package dk.nsp.idsas.ws;

import dk.nsp.idsas.security.IdsasContextBuilder;
import dk.sds.nsp.security.Security;
import dk.sds.nsp.security.SecurityContext;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.CreateBlurringRequestType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.EmptyRequest;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.GetSaltRequestType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.IdsasBlurringServicePortType;
import org.springframework.beans.factory.annotation.Autowired;

import javax.jws.WebService;
import javax.servlet.annotation.WebServlet;
import javax.xml.ws.BindingType;
import javax.xml.ws.soap.Addressing;

import static javax.xml.ws.soap.SOAPBinding.SOAP11HTTP_BINDING;

@WebServlet(name="IdsasBlurringService", urlPatterns={"/blurring"})
@WebService(serviceName = "IdsasBlurringService", wsdlLocation = "wsdl/idsas-blurring.wsdl",
        targetNamespace = "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/",
        portName = "IdsasBlurringServicePort")
@BindingType(value = SOAP11HTTP_BINDING)
@Addressing(enabled = true, required = false)
public class IdsasBlurringServiceWS extends IdsasAbstractWS implements IdsasBlurringServicePortType {

    @Autowired
    private IdsasContextBuilder idsasContextBuilder;

    @Override
    public String createBlurring(CreateBlurringRequestType createBlurringRequest) {
        SecurityContext securityContext = Security.getSecurityContext();
        System.out.println("securityContext ticket isPresent 1: " + securityContext.getTicket().isPresent());

        System.out.println("create blurring!");
        System.out.println("createBlurring: " + createBlurringRequest.getPatientId().getId());

        return "void!";
    }

    @Override
    public String getSalt(GetSaltRequestType getSaltRequest) {
        SecurityContext securityContext = Security.getSecurityContext();
        System.out.println("securityContext ticket isPresent 2: " + securityContext.getTicket().isPresent());
        System.out.println("securityContext ticket isValid 2: " + securityContext.getTicket().get().isValid());

        System.out.println("getSalt: " + getSaltRequest.getDateTime());
        return "getSalt: " + getSaltRequest.getDateTime();
    }

    @Override
    public String getCurrentSalt(EmptyRequest getCurrentSaltRequest) {
        return "getCurrentSalt";
    }
}
