package dk.nsp.idsas.ws;

import dk.sds.nsp.security.Security;
import dk.sds.nsp.security.SecurityContext;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.GetOrgsToBlurRequestType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.IdsasOrganisationServicePortType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.OrgsToBlurResponseType;

import javax.jws.WebService;
import javax.servlet.annotation.WebServlet;
import javax.xml.ws.BindingType;
import javax.xml.ws.soap.Addressing;

import static javax.xml.ws.soap.SOAPBinding.SOAP11HTTP_BINDING;

@WebServlet(name="IdsasOrganisationService", urlPatterns={"/organisations"})
@WebService(serviceName = "IdsasOrganisationService", wsdlLocation = "wsdl/idsas-organisations.wsdl",
        targetNamespace = "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/",
        portName = "IdsasOrganisationServicePort")
@BindingType(value = SOAP11HTTP_BINDING)
@Addressing(enabled = true, required = false)
public class IdsasOrganisationServiceWS extends IdsasAbstractWS implements IdsasOrganisationServicePortType {
    @Override
    public OrgsToBlurResponseType getOrgsToBlur(GetOrgsToBlurRequestType getOrgsToBlurRequest) {
        SecurityContext securityContext = Security.getSecurityContext();
        System.out.println("getOrgsToBlur: " + getOrgsToBlurRequest.getPatientId().getId());
        return new OrgsToBlurResponseType();
    }
}
