package dk.nsp.idsas.security.data;

import dk.sds.nsp.security.SecurityContext;

import java.util.Collections;
import java.util.Optional;
import java.util.Set;

public class TestUser implements SecurityContext.User {

    private static final class DevelopmentCredentials implements Credentials {

        @Override
        public Optional<String> getAuthorizationCode() {
            return Optional.of("NS362");
        }

        @Override
        public Optional<String> getEducationCode() {
            return Optional.of("7170");
        }

        @Override
        public Optional<String> getNationalRole() {
            return Optional.empty();
        }

        @Override
        public Optional<String> getUnverifiedRole() {
            return Optional.empty();
        }

        @Override
        public Set<String> getPowerOfAttorneyPrivileges() {
            return Collections.emptySet();
        }

    }

    @Override
    public UserType getUserType() {
        return UserType.Citizen;
    }

    @Override
    public PersonIdentifierFormat getIdentifierFormat() {
        return PersonIdentifierFormat.CPR;
    }

    @Override
    public String getIdentifier() {
        return "0101701423";
    }

    @Override
    public Optional<String> getGivenName() {
        return Optional.of("Hans Helmuth");
    }

    @Override
    public Optional<String> getSurname() {
        return Optional.of("Hansen");
    }

    @Override
    public Optional<Credentials> getCredentials() {
        return Optional.of(new DevelopmentCredentials());
    }

    @Override
    public Optional<SecurityContext.PersistentUniqueKey> getPersistentUniqueKey() {
        return Optional.empty();
    }

}