package dk.nsp.idsas.ws;

import dk.nsp.idsas.setup.ServiceSetup;
import dk.nsp.idsas.setup.WebSetup;
import org.apache.log4j.Logger;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;

import static dk.nsp.idsas.setup.ServiceSetup.ANNOTATION_CONFIG_CONTEXT;

@WebListener
public class IdsasContextListener implements ServletContextListener {
	private static final Logger logger = Logger.getLogger(IdsasContextListener.class);

	@Override
	public void contextInitialized(ServletContextEvent event) {
		logger.info("IdsasContextListener contextInitialized");
		AnnotationConfigApplicationContext applicationContext = new AnnotationConfigApplicationContext();
		applicationContext.register(ServiceSetup.class);
		applicationContext.register(WebSetup.class);
		applicationContext.refresh();

		event.getServletContext().setAttribute(ANNOTATION_CONFIG_CONTEXT, applicationContext);
	}

	@Override
	public void contextDestroyed(ServletContextEvent sce) {
		Object ctx = sce.getServletContext().getAttribute(ANNOTATION_CONFIG_CONTEXT);
		if(ctx instanceof AnnotationConfigApplicationContext) {
			((AnnotationConfigApplicationContext)ctx).close();
		}
	}

}
